//+------------------------------------------------------------------+
//|                                                  ATRStops_v1.mq5 |
//|                                     Copyright   |
//|                                                     lucka88@i.ua |
//+------------------------------------------------------------------+
#property copyright " "
#property link      "lucka88@i.ua"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//---- plot Buy
#property indicator_label1  "Buy"
#property indicator_type1   DRAW_SECTION
#property indicator_color1  DodgerBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//---- plot Sell
#property indicator_label2  "Sell"
#property indicator_type2   DRAW_SECTION
#property indicator_color2  Red
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1


//+------------------------------------------------------------------+
//|                                                         |
//+------------------------------------------------------------------+



//Market   

/*struct Market 
{
     datetime& time,
     double& open[],
     double& high[],
     double& low[],
     double& close[],
     long& tick_volume[],
     long& volume[],
     int& spread[]
}


*/

//  

struct ATRStopParametr
{
int      _Length;
int      _ATRperiod;
double   _Kv;
}



//--- input parameters
input int      Length=10;
input int      ATRperiod=5;
input double   Kv=2.5;


//--- indicator buffers
double         BuyBuffer[];
double         SellBuffer[];
//ATRStopParametr   Parametr;

#define DATA_LIMIT 37


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,BuyBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,SellBuffer,INDICATOR_DATA);
//--- set accuracy
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,const int prev_calculated,
                const datetime &Time[],
                const double &Open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &TickVolume[],
                const long &Volume[],
                const int &Spread[])
  {
   int toCount = (int)MathMin(rates_total, rates_total - prev_calculated + 1);
   
   if (prev_calculated < 0 || prev_calculated > rates_total)
   {
      toCount = rates_total;
   }

ATRStopParametr      Parametr={_Length=Length,ATRperiod,Kv};

   for(int i=toCount;i>=0;i--)
     {
     double buf=ATRStop(i,High,Low,Close,Parametr);
     if (buf>0) BuyBuffer [i]= buf;
     if (buf<0) SellBuffer[i]=-buf;
     
     }

  
   return(rates_total);
  }
//+------------------------------------------------------------------+




double ATRStop(int shift ,const double &High[],const double &Low[],const double &Close[],ATRStopParametr Parametr)
{
double         smin[];
double         smax[];
double         trend[];
double         ATR_Bufer[];
double         buff[];
//--- handles for ATR
int            ATRHandle;


ATRHandle=iATR(NULL,0,Parametr._ATRperiod);
if(CopyBuffer(ATRHandle,0,0,to_copy,ATR_Bufer)<=0)
   {
   Print("Getting fast SMA is failed! Error",GetLastError());
   return(0);
   }

smin[shift]=-100000; smax[shift]=100000;
  
      for(int i=Parametr._Length-1;i>=0;i--)
        {
         smin[shift]=MathMax( smin[shift], High[shift+i] - Parametr._Kv*ATR_Bufer(shift+i));
         smax[shift]=MathMin( smax[shift], Low[shift+i] + Parametr._Kv*ATR_Bufer(shift+i));
        }

      trend[shift]=trend[shift+1];
      if(Close[shift] > smax[shift+1])trend[shift]= 1;
      if(Close[shift] < smin[shift+1])trend[shift]=-1;
      if(trend[shift] >0)
        {
         if(smin[shift]<smin[shift+1])smin[shift]=smin[shift+1];
         return(smin[shift]*trend[shift]);
        }
      if(trend[shift] <0)
        {
         if(smax[shift]>smax[shift+1])smax[shift]=smax[shift+1];
         return(smax[shift]*trend[shift]);
        }
}

